<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $current_user,$wpdb,$wpscimportfunction;

if( !$current_user->has_cap('manage_options') ) exit();

$terms = get_terms('wpsp_canned_reply_categories', array( "hide_empty" => 0 ));

$wpsc_args = array(
	'post_type' => 'wpsc_canned_reply',
	'posts_per_page' => -1,
	'post_status' => array('publish', 'pending', 'draft', 'auto-draft', 'future', 'private', 'inherit', 'trash')    
);

$wpsc_posts = get_posts($wpsc_args);

if ($wpsc_posts) {
	foreach ($wpsc_posts as $post) {
		wp_delete_post( $post->ID );
	}
}

$args = array(
  'post_type'    => 'wpsp_canned_reply',
	'posts_per_page' => -1,
	'post_status' => array('publish', 'pending', 'draft', 'auto-draft', 'future', 'private', 'inherit', 'trash')    
);

$posts = get_posts($args);

if ($posts) {
	
	foreach ($posts as $post) {
		
		$category_id = array();
		$categories = get_the_terms($post->ID, "wpsp_canned_reply_categories");	
		if ($categories) {
			foreach ($categories as $category) {
				$term = wp_insert_term( $category->name, 'wpsc_canned_reply_categories' );
				if (!is_wp_error($term) && isset($term['term_id'])) {
					$category_id[] = $term['term_id'];
				}
			}
		}
		
		$post_id = wp_insert_post(array(
			'post_title'    => $post->post_title,
			'post_content'  => $post->post_content,
			'post_status'   => $post->post_status,
			'post_type'			=> 'wpsc_canned_reply'
			));
	 
		if($post_id){
			wp_set_post_terms( $post_id, $category_id,'wpsc_canned_reply_categories');
			add_post_meta( $post_id, 'wpsc_agent_visibility', 0 );
			add_post_meta( $post_id, 'wpsc_author', $current_user->ID );
		}
 	
	}
}