<?php 
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $current_user,$wpsupportplus,$wpdb,$wpscimportfunction,$wpscfunction;

if( !$current_user->has_cap('manage_options') ) exit();

$wpsp_categories = $wpscimportfunction->get_wpsp_categories();

$agent_data = array();

foreach ($wpsp_categories as $category) {
  
  $category_agents = array();
	$supervisor = $category->supervisor;
  
  if ($supervisor) {
    $supervisor_id_array = unserialize($supervisor);
    foreach ($supervisor_id_array as $supervisor_id) {
      $agent_term = get_term_by('slug','agent_'.$supervisor_id,'wpsc_agents');
      $category_agents[] =  $agent_term->term_id;
    }
    $agent_data[$category->id] = $category_agents;
  }

}

if ($agent_data) {

  foreach ($agent_data as $cat_key => $value) {
    $condition_data = array();
    if ($value) {
      $category_name = $wpdb->get_var("SELECT name from {$wpdb->prefix}wpsp_catagories WHERE id = ".$cat_key);
      $wpsc_category_data = get_term_by('name',$category_name,'wpsc_categories');
      $wpsc_category = get_term_by('slug','ticket_category','wpsc_ticket_custom_fields');
      $category_id = $wpsc_category->term_id;
    
      $cond_val= array(
        "field" => $category_id,
        "compare" => "match",
        "cond_val" => $wpsc_category_data->term_id
      );
      
      $condition_data[] = json_encode($cond_val);
      $conditions =   implode(',',$condition_data);
      
      $term = wp_insert_term($category_name , 'wpsc_caa' );
      if (!is_wp_error($term) && isset($term['term_id'])) {
        $load_order = $wpdb->get_var("select max(meta_value) as load_order from {$wpdb->prefix}termmeta WHERE meta_key='wpsc_caa_load_order'");
        $load_order = $load_order ? $load_order : 0;
        add_term_meta ($term['term_id'], 'load_order', ++$load_order);
        add_term_meta ($term['term_id'], 'agent_ids', $value);
        add_term_meta ($term['term_id'], 'conditions', '['.$conditions.']');
      }
    }
  }
}