
/**
 * Take consent to continue importing
 */
function wpsp_setting_import(){
    
    var consent = confirm(
        'Please make sure you read information given about import functionality.\n'
      + 'Are you sure you want to continue?'
    );
    if (!consent) return;
    
    var replace_html_str = '<p style="font-size:15px;text-align:center;margin-top:30px;">This may take few minutes, please do not press "Back" or "Refresh" button until it finishes.</p>'
                          +'<p id="wpsc_setting_import_info" class="help-block" style="font-size:12px;margin-top:30px;">Removing existing tickets...</p>'
                          + '<div class="progress" style="position: initial !important; height:20px !important; width:100% !important;">'
                            +  '<div id="wpsc_db_upgrade_progress_bar" class="progress-bar" role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: 0%;"></div>'
                          + '</div>';
    jQuery('#wpsc_upgrade_dialog_container').html(replace_html_str);
    
    wpsc_run_setting_import(1);
    
}

/**
 * Run setting import
 */
function wpsc_run_setting_import( page_no ) {
  var data = {
    action: 'wpsc_run_setting_import',
    page_no : page_no
  };
  jQuery.post(wpsc_admin.ajax_url, data, function(response_str) {
    var response = JSON.parse(response_str);
    jQuery('#wpsc_db_upgrade_progress_bar').css('width',response.completed+'%');
    jQuery('#wpsc_setting_import_info').text(response.next_page_text);
    if(response.is_next===1){
      wpsc_run_setting_import( response.page_no );
    } else {
      wpsp_tickets_import();
    }
  });
}

/**
 * Start importing tickets
 */
function wpsp_tickets_import(){
     
  var replace_html_str = '<p style="font-size:15px;text-align:center;margin-top:30px;">This may take few minutes, please do not press "Back" or "Refresh" button until it finishes.</p>'
                    +'<p id="wpsc_setting_import_info" class="help-block" style="font-size:12px;margin-top:30px;">Importing tickets...</p>'
                    + '<div class="progress" style="position: initial !important; height:20px !important; width:100% !important;">'
                    +  '<div id="wpsc_db_upgrade_progress_bar" class="progress-bar" role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: 0%;"></div>'
                    + '</div>';
  
  jQuery('#wpsc_upgrade_dialog_container').html(replace_html_str);
  wpsc_run_ticket_import(1);
}
 
 /**
  * Run ticket import
  */
function wpsc_run_ticket_import( page_no ) {
  
  var data = {
    action: 'wpsc_run_ticket_import',
    page_no : page_no
  };
  
  jQuery.post(wpsc_admin.ajax_url, data, function(response_str) {
  
    var response = JSON.parse(response_str);
    jQuery('#wpsc_db_upgrade_progress_bar').css('width',response.completed+'%');
     jQuery('#wpsc_setting_import_info').html(response.next_page_text);

    if(response.is_next===1){
      wpsc_run_ticket_import( response.page_no );
    } else {
      wpsp_import_addons();
      //jQuery('#wpsc_upgrade_dialog_container').html("Import done Successfully");
    }
  });
}

/*
  * Import Add-ons
 */
function wpsp_import_addons(){
     
  var replace_html_str = '<p style="font-size:15px;text-align:center;margin-top:30px;">This may take few minutes, please do not press "Back" or "Refresh" button until it finishes.</p>'
                      +'<p id="wpsc_setting_import_info" class="help-block" style="font-size:12px;margin-top:30px;">Importing Add-ons...</p>'
                      + '<div class="progress" style="position: initial !important; height:20px !important; width:100% !important;">'
                      +  '<div id="wpsc_db_upgrade_progress_bar" class="progress-bar" role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: 0%;"></div>'
                      + '</div>';
  
  jQuery('#wpsc_upgrade_dialog_container').html(replace_html_str);
     
  wpsc_run_import_addons(1);
}
 
/*
  Run setting addons
*/
function wpsc_run_import_addons( page_no ) {
   
  var data = {
    action: 'wpsc_run_import_addons',
    page_no : page_no
  };
  
  jQuery.post(wpsc_admin.ajax_url, data, function(response_str) {
    var response = JSON.parse(response_str);
    jQuery('#wpsc_db_upgrade_progress_bar').css('width',response.completed+'%');
    jQuery('#wpsc_setting_import_info').text(response.next_page_text);
    if(response.is_next===1){
      wpsc_run_import_addons( response.page_no );
    } else {
      jQuery('#wpsc_upgrade_dialog_container').html("<p style ='text-align:center;font-size:18px;margin-top: 50px;position: relative;'> Import done successfully! </p>");
    }
  });
}