<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

if ( ! class_exists( 'WPSC_SCIMP_Admin' ) ) :
  
    final class WPSC_SCIMP_Admin {
      
        /**
         * loads JS script required on import page
         */
        public function loadScripts(){
          
            if( isset($_REQUEST['page']) && $_REQUEST['page'] == 'wpsc-sc-import' ){
              
                wp_enqueue_script('wpsc-scimp-admin', WPSC_SCIMP_PLUGIN_URL.'admin.js?version='.WPSC_VERSION, array('jquery'), null, true);
              
            }
          
        }
        
        /**
         * Adds submenu
         */
        public function register_dashboard_menu(){
          
            add_submenu_page(
              'wpsc-tickets',
              __( 'WP Support Plus Import', 'supportcandy' ),
              __( 'WPSP Import', 'supportcandy' ),
              'manage_options',
              'wpsc-sc-import',
              array( $this, 'load_wpsp_import_page' )
            );
          
        }
        
        /**
         * Support Plus import dashboard page
         */
        public function load_wpsp_import_page(){
          
            include_once( WPSC_SCIMP_ABSPATH . 'import_page.php' );
          
        }
				
				/**
				 * Run Settings import
				 */
				 public function run_setting_import(){
           
             include_once( WPSC_SCIMP_ABSPATH . 'run_setting_import.php' );
						 die();
           
         }
				 /*
				 		Import Tickets
				  */
				 public function run_ticket_import(){
					 include_once( WPSC_SCIMP_ABSPATH . 'import_tickets.php' );
						die();
					}
					/*
					Import Add-ons
					 */
					 public function run_import_addons(){
             
               include_once( WPSC_SCIMP_ABSPATH . 'import_addons.php' );
  						 die();
             
           }
    }
  
endif;

