<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $current_user;

if( !$current_user->has_cap('manage_options') ) exit();

$current_page = isset($_POST['page_no']) ? intval($_POST['page_no']) : 1;
$total_pages  = 5;
$completed    = ceil(($current_page/$total_pages)*100);
$is_next      = $current_page < $total_pages ? 1 : 0;

switch ($current_page) {
  
		case 1:
			//Import all data of Export Ticket
			include_once( WPSC_SCIMP_ABSPATH . 'addons/import_export_ticket.php' );
			$next_page_text = 'Importing Export Tickets...';
			break;
      
    case 2:
			// Import all Usergroup data
			include_once( WPSC_SCIMP_ABSPATH . 'addons/import_usergroup.php' );
      $next_page_text = 'Importing Usergroup...';
			break;
      
    case 3:
			//Import all Canned Reply data
			include_once( WPSC_SCIMP_ABSPATH . 'addons/import_canned_reply.php' );
      $next_page_text = 'Importing Canned Reply...';
      break;
			
		case 4:
			//Importing Automatic Close Ticket
			include_once( WPSC_SCIMP_ABSPATH . 'addons/import_automatic_close_ticket.php' );
			$next_page_text = 'Importing Automatic Close Ticket...';
			break;
		
		case 5 :
		//Importing Supervisor Rule
		include_once( WPSC_SCIMP_ABSPATH . 'addons/importing_supervisor_rule.php' );
		$next_page_text = 'Importing Supervisor Rule...';
		break;
      
}

$response = array(
  'completed'      => $completed,
  'is_next'        => $is_next,
  'page_no'        => $current_page+1,
  'next_page_text' => $next_page_text,
);

echo json_encode($response);
