<?php
if ( ! defined( 'ABSPATH' ) ) {
  exit; // Exit if accessed directly
}

global $wpscfunction, $current_user, $wpdb,$wpscimportfunction,$wpsupportplus;

/**
 * Exit if logged in user do not have administrator capabilities
 */
if( !$current_user->has_cap('manage_options') ) exit();

$post_per_page = 20;
$page_no = isset($_POST['page_no']) ? intval($_POST['page_no']) : 1;
$offset  = $post_per_page * ($page_no-1);

$default_category = get_option('wpsc_default_ticket_category');

$default_status   = get_option('wpsc_default_ticket_status');

$default_priority = get_option('wpsc_default_ticket_priority');

// Get Custom Fields
$custom_fields = $wpscimportfunction->get_wpsc_custom_fields();

//Get Ticket List
$sql = "select * from {$wpdb->prefix}wpsp_ticket LIMIT ".$offset.",".$post_per_page;
$tickets  = $wpdb->get_results($sql);

// Check table Timer Present or not
$check_tbl_timer = $wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}wpsp_timer'");

$path = WP_CONTENT_DIR.'/uploads/wpsp';

foreach ($tickets as $ticket) {

  $wp_category_name = $wpdb->get_var("SELECT name from {$wpdb->prefix}wpsp_catagories where id = ".$ticket->cat_id);
  $category_data ='';
  if ($wp_category_name) {
    $category_data = get_term_by('name',$wp_category_name, 'wpsc_categories');
  }
  $ticket_category = $category_data ? $category_data->term_id : $default_category;
  
  $wp_status_name = $wpdb->get_var("select name from {$wpdb->prefix}wpsp_custom_status where id = ".$ticket->status_id);
  $status_data = '';
  if ($wp_status_name) {
    $status_data = get_term_by('name',$wp_status_name, 'wpsc_statuses');
  }
  $ticket_status = $status_data ? $status_data->term_id : $default_status;
  
  $wp_priority_name = $wpdb->get_var("select name from {$wpdb->prefix}wpsp_custom_priority WHERE id =".$ticket->priority_id);
  $priority_data = '';
  if($wp_priority_name){
    $priority_data = get_term_by('name',$wp_priority_name,'wpsc_priorities');
  }
  $ticket_priority = $priority_data ? $priority_data->term_id : $default_priority ; 
 
  $values = array(
    'id'           => $ticket->id,
    'ticket_status' => $ticket_status,
    'customer_name' => $ticket->guest_name,
    'customer_email' => $ticket->guest_email,
    'ticket_subject' => $ticket->subject,
    'user_type' => $ticket->type,
    'ticket_category' => $ticket_category,
    'ticket_priority' => $ticket_priority,
    'date_created' => $ticket->create_time,
    'date_updated' => $ticket->update_time,
    'ip_address' => $ticket->ip_address,
    'agent_created' => $ticket->agent_created,
    'ticket_auth_code' => $wpscfunction->getRandomString(10),
    'active' => $ticket->active
  );
   
  $ticket_id = $wpscfunction->create_new_ticket($values);
  
  $agent_id = $wpscimportfunction->get_user_agent_id($ticket->assigned_to);
  
  $wpscfunction->add_ticket_meta($ticket_id,'assigned_agent',$agent_id);
  
  $wpsp_custom_fields = $wpdb->get_results("SELECT * from {$wpdb->prefix}wpsp_custom_fields ");
  
  foreach ($wpsp_custom_fields as $wp_custom_fields) {
    
    $wpsp_tf_type = $wp_custom_fields->field_type;
    $value = $ticket->{'cust'.$wp_custom_fields->id};
    $wpsc_cust_field = get_term_by('name',$wp_custom_fields->label,'wpsc_ticket_custom_fields');
    
    switch ($wpsp_tf_type) {
      case '1':
      case '2':
      case '4':
      case '5':
      case '7':
      case '9':
      case '10':
      case '11':
      case '12':
      case '13':
        if($value){
          $wpscfunction->add_ticket_meta($ticket_id, $wpsc_cust_field->slug,$value);
        }
      break;
    
      case '3':
      $arrVal = explode('|||',$value);
      if($arrVal){
        foreach ($arrVal as $value) {
          $wpscfunction->add_ticket_meta($ticket_id, $wpsc_cust_field->slug,$value);
        }
      }
      break;
      
      case '8':
      
      $arrVal = explode('|||',$value);
      if($arrVal){
        foreach ($arrVal as $arr_value) {
          if ($arr_value) {
            
            $attachment_count = get_option('wpsc_attachment_count');
            if(!$attachment_count) $attachment_count = 1;
            
            $get_attachment = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_attachments where id = " .$arr_value); 
            $term = wp_insert_term( 'attachment_'.$attachment_count, 'wpsc_attachment' );
            if(!$term) die(); 
            update_option('wpsc_attachment_count',++$attachment_count);

            $upload_dir = wp_upload_dir();
            add_term_meta ($term['term_id'], 'filename', $get_attachment->filename);
            
            $file = basename($get_attachment->filepath);
            // $save_file_name = str_replace(' ','_',$get_attachment->filename);
            // $save_file_name = str_replace(',','_',$get_attachment->filename);
            // $save_file_name = explode('.', $save_file_name);
            
            $save_file_name = explode('.', $get_attachment->filename);
            $img_extensions = array('png','jpeg','jpg','bmp','pdf','PNG','JPEG','JPG','BMP','PDF');
            $extension = '';
            
            if(isset($save_file_name[1])){
              $extension   =  $save_file_name[1];
              if(!in_array($extension, $img_extensions)){
                add_term_meta ($term['term_id'], 'is_image', '0');
              } else {
                add_term_meta ($term['term_id'], 'is_image', '1');
              }
            } else {
              add_term_meta ($term['term_id'], 'is_image', '0');
            }
            
            add_term_meta ($term['term_id'], 'save_file_name', $file);
            add_term_meta ($term['term_id'], 'active', '1');
            add_term_meta ($term['term_id'], 'time_uploaded', $get_attachment->upload_time);
            add_term_meta($term['term_id'],'wpsp_file', 1);
            $wpscfunction->add_ticket_meta($ticket_id, $wpsc_cust_field->slug,$term['term_id']);

          }
        }
      }
      break;
    
      case 6 :
        if($value) {
          $wpscfunction->add_ticket_meta($ticket_id, $wpsc_cust_field->slug,$value);
        }
      break;
      
      default:
      break;
    
    }
  }
  
  $ticket_thread_count = $wpdb->get_var("SELECT COUNT(*) from {$wpdb->prefix}wpsp_ticket_thread where ticket_id=".$ticket->id);
  
  $limit = 10;
  $count = $ticket_thread_count/$limit;
  $offset = 0;

  while($count > 0){
  
    $ticket_threads = $wpdb->get_results("select * from {$wpdb->prefix}wpsp_ticket_thread where ticket_id=".$ticket->id." LIMIT ".$limit." OFFSET ".($offset * $limit));
  
    foreach ($ticket_threads as $ticket_thread) {
  
      $attachments = array();
      $flag = false;
      $log_str = '';
      
      if ($ticket_thread->is_note == '0' ) {
  
        $thread_type = 'reply';
        $flag = true;
  
      } elseif ($ticket_thread->is_note == '1') {
  
        $thread_type = 'note';
        $flag = true;
  
      } elseif ($ticket_thread->is_note == '2') {
      
        // Change Assign agent
      
        $agents = explode( ',', $ticket_thread->body );
        $agent_name = array();
  
        foreach ( $agents as $agent ){
          $user = get_userdata($agent);
          if($user){
            $agent_name[] = $user->display_name;
          } else {
            $agent_name[] = __('None','supportcandy');
          }
        }
  
        $log_str = sprintf( __('%1$s changed assign agent to %2$s','supportcandy'), '<strong>'.$ticket_thread->guest_name.'</strong>','<strong>'.implode(', ', $agent_name).'</strong>');
        
      } else if($ticket_thread->is_note == '3') {
        
        // Change Status
        if($ticket_thread->body){
          $status_name    = $wpdb->get_var( "select name from {$wpdb->prefix}wpsp_custom_status where id=".$ticket_thread->body );
          
          if (isset($status_name)) {
            $wpsc_status = get_term_by('name',$status_name,'wpsc_statuses');
            $log_str = sprintf( __('%1$s changed status to %2$s','supportcandy'), '<strong>'.$ticket_thread->guest_name.'</strong>','<strong>'. $wpsc_status->name.'</strong>' );
          }else {
            $log_str = sprintf( __('%1$s changed status','supportcandy'), '<strong>'.$ticket_thread->guest_name.'</strong>');
          }
          
        }
      
      } else if($ticket_thread->is_note == '4') {
        
        //Change Category
        if($ticket_thread->body){
          
          $category_name = $wpdb->get_var( "select name from {$wpdb->prefix}wpsp_catagories where id=".$ticket_thread->body );
          if (isset($category_name)) {
            $wpsc_categories = get_term_by('name',$category_name,'wpsc_categories');
            $log_str = sprintf( __('%1$s changed category to %2$s','supportcandy'), '<strong>'.$ticket_thread->guest_name.'</strong>','<strong>'. $wpsc_categories->name.'</strong>' );
          }else {
            $log_str = sprintf( __('%1$s changed category','supportcandy'), '<strong>'.$ticket_thread->guest_name.'</strong>');
          }
        }
  
      } else if($ticket_thread->is_note == '5') {
    
        //Change Priority
        if ($ticket_thread->body) {
          
          $priority_name = $wpdb->get_var( "select name from {$wpdb->prefix}wpsp_custom_priority where id=".$ticket_thread->body );
          
          if (isset($priority_name)) {
          
            $wpsc_priorities = get_term_by('name',$priority_name,'wpsc_priorities');
            $log_str = sprintf( __('%1$s changed priority to %2$s','supportcandy'), '<strong>'.$ticket_thread->guest_name.'</strong>','<strong>'. $wpsc_priorities->name.'</strong>' );
          }else {
            
            $log_str = sprintf( __('%1$s changed priority','supportcandy'), '<strong>'.$ticket_thread->guest_name.'</strong>');
          }
        
        }
        
      } else if($ticket_thread->is_note == '6') {
        
        // Change_raised_by
        
        $user = get_userdata($ticket_thread->created_by);
        if ($user) {
          $log_str = sprintf( __('%1$s changed raised by to %2$s','supportcandy'), '<strong>'.$user->display_name.'</strong>','<strong>'.$ticket_thread->guest_name.'</strong>');
        }else {
          $log_str = sprintf( __('%1$s changed raised by ','supportcandy'),'<strong>'.$ticket_thread->guest_name.'</strong>');
        }
      } 
  
      if($ticket_thread->attachment_ids){
        
        $attachment_count = get_option('wpsc_attachment_count');
        
        if(!$attachment_count){
          $attachment_count = 1;
        }
        
        $attachment_ids = explode(',',$ticket_thread->attachment_ids);
        
        foreach ($attachment_ids as $attachment_id) {
          
          $get_attachment = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_attachments where id = " .$attachment_id); 

          $term = wp_insert_term( 'attachment_'.$attachment_count, 'wpsc_attachment' );
            if(!$term) die(); 
            update_option('wpsc_attachment_count',++$attachment_count);
          
            add_term_meta ($term['term_id'], 'filename', $get_attachment->filename);
            $file = basename($get_attachment->filepath);
          
            $save_file_name = explode('.', $get_attachment->filename);
            $img_extensions = array('png','jpeg','jpg','bmp','pdf','PNG','JPEG','JPG','BMP','PDF');
            $extension = '';
            if(isset($save_file_name[1])){
              $extension   =  $save_file_name[1];
              if(!in_array($extension, $img_extensions)){
                add_term_meta ($term['term_id'], 'is_image', '0');
              } else {
                add_term_meta ($term['term_id'], 'is_image', '1');
              }
            }else {
              add_term_meta ($term['term_id'], 'is_image', '0');
            }
          
          
            add_term_meta ($term['term_id'], 'save_file_name', $file);
            add_term_meta ($term['term_id'], 'active', '1');
            add_term_meta ($term['term_id'], 'time_uploaded', date("Y-m-d H:i:s"));
            add_term_meta($term['term_id'],'wpsp_file', 1);
            $attachments[] = $term['term_id'];
          }
        }
      
        if($flag){
          
          $thread_args = array(
            'ticket_id'      => $ticket_id,
            'reply_body'     => '' ,
            'customer_name'  => $ticket_thread->guest_name,
            'customer_email' => $ticket_thread->guest_email,
            'attachments'    => $attachments,
            'create_time'    => $ticket_thread->create_time,
            'thread_type'    => $thread_type
          );
          
        } else {
        
        $thread_args = array(
          'ticket_id'      => $ticket_id,
          'reply_body'     => $log_str,
          'thread_type'    => 'log',
          'create_time'    => $ticket_thread->create_time
        );
      }
    
      $thread_id = $wpscimportfunction->submit_thread($thread_args);
      if($flag){
        global $wpdb;
        $wpdb->get_results("UPDATE {$wpdb->prefix}posts SET post_content='".addslashes($ticket_thread->body)."' WHERE ID=".$thread_id);
      }
    }
    
    $count--;
    $offset++;
    
  }
  
  if ($check_tbl_timer) {
  
    $timer_log = $wpdb->get_results( "select * from {$wpdb->prefix}wpsp_timer where ticket_id= ".$ticket_id);
    if ($timer_log) {
  
      foreach ($timer_log as $key => $log) {
  
        $values=array(
          'post_id'=>	$log->ticket_id,
          'start_time'=> $wpscimportfunction->get_time_local_to_utc($log->start_time),
          'end_time'=> $wpscimportfunction->get_time_local_to_utc($log->end_time),
          'time_spend'=> $log->time_spend,
          'timer_status'=>	$log->timer_status
        );
        $wpdb->insert($wpdb->prefix.'wpsc_timer',$values);
      }
    }
    
  }
}

$current_page   = $page_no;
$total_items    = $wpdb->get_var(" SELECT count(id) from {$wpdb->prefix}wpsp_ticket ");
$total_pages    = $total_items ? ceil($total_items/$post_per_page) : 1;
$completed      = ceil(($current_page/$total_pages)*100);
$is_next        = $current_page < $total_pages ? 1 : 0;

$start_index    = (($post_per_page * $page_no) - $post_per_page) + 1 ;
$end_index      = $post_per_page + ($post_per_page * ($page_no-1));
$next_page_text = "Importing ".$start_index. "-".$end_index. " from " .$total_items." tickets";

if(!$is_next){
  $label_count_history = get_option( 'wpsc_label_count_history' );
  update_option( 'wpsc_label_count_history', ++$label_count_history );
}

$response = array(
  'completed' => $completed,
  'is_next' => $is_next,
  'page_no' => $current_page+1,
  'next_page_text' => $next_page_text
);
echo json_encode($response);