<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $current_user;

if( !$current_user->has_cap('manage_options') ) exit();

$current_page = isset($_POST['page_no']) ? intval($_POST['page_no']) : 1;
$total_pages  = 10;
$completed    = ceil(($current_page/$total_pages)*100);
$is_next      = $current_page < $total_pages ? 1 : 0;

switch ($current_page) {
  
		case 1:
      // remove all records in tickets table of SupportCandy
      include_once( WPSC_SCIMP_ABSPATH . 'settings/remove_tickets.php' );
      $next_page_text = 'Removing existing tickets...';
      break;
      
		case 2:
	    // remove all existing supportcandy statuses and import from SP
			include_once( WPSC_SCIMP_ABSPATH . 'settings/import_statuses.php' );
	    $next_page_text = 'Importing statuses...';
	    break;      
    
      
    case 3:
      // remove all existing supportcandy categories and import from SP
      include_once( WPSC_SCIMP_ABSPATH . 'settings/import_categories.php' );
      $next_page_text = 'Importing categories...';
      break;
      
    case 4:
		// remove all existing supportcandy priorities and import from SP
			include_once( WPSC_SCIMP_ABSPATH . 'settings/import_priorities.php' );
      $next_page_text = 'Importing priorities...';
      break;
      
    case 5:
		// remove all existing supportcandy custom fields and import from SP
      include_once( WPSC_SCIMP_ABSPATH . 'settings/import_custom_fields.php' );
      $next_page_text = 'Importing custom fields...';
      break;
      
    case 6:
			// remove all existing supportcandy agents and import from SP
			include_once( WPSC_SCIMP_ABSPATH . 'settings/import_agents.php' );
      $next_page_text = 'Importing agents...';
      break;
      
    case 7:
			// remove all existing ticket list (customer and agent) and import from SP
			include_once( WPSC_SCIMP_ABSPATH . 'settings/import_ticket_list_fields.php' );
			$next_page_text = 'Importing ticket list...';
      break;
      
    case 8:
  		// remove all existing email notifications and import from SP    
    	include_once( WPSC_SCIMP_ABSPATH . 'settings/import_email_notifications.php' );
      $next_page_text = 'Importing email notifications...';
      break;
      
    case 9:
      //Import all the settings
			include_once( WPSC_SCIMP_ABSPATH . 'settings/import_settings.php' );
      $next_page_text = 'Importing settings...';
      break;
    
		case 10 :
		   // import widgets 
		   include_once(WPSC_SCIMP_ABSPATH . 'settings/import_widgets.php');
			 $next_page_text = 'Importing widgets....';
			 break;	
}

$response = array(
  'completed'      => $completed,
  'is_next'        => $is_next,
  'page_no'        => $current_page+1,
  'next_page_text' => $next_page_text,
);

echo json_encode($response);
