<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $current_user,$wpsupportplus,$wpdb,$wpscimportfunction,$wpscfunction;

if( !$current_user->has_cap('manage_options') ) exit();

/*
  Get all agents
 */
$agents = $wpscimportfunction->wpsc_get_all_agents();

/**
 * Get all agent roles
 */
$agent_role = get_option('wpsc_agent_role');

foreach ($agent_role as $key => $agent) {
	if ($key > 1) {
		unset($agent_role[$key]);
	}
}
update_option('wpsc_agent_role',$agent_role);

/**
 * Get all agent settings
 */
$wpsp_agent_settings = $wpsupportplus->functions->get_agent_settings();

if (!array_key_exists('2', $agent_role)) {
	$agent_role[2] = array(
		'label' => __('Agent','supportcandy'),
		'view_unassigned' => 0,
		'view_assigned_me' => 1,
		'view_assigned_others' => 0,
		'assign_unassigned' => $wpsp_agent_settings['agent_allow_assign_ticket'],
		'assign_assigned_me' => $wpsp_agent_settings['agent_allow_assign_ticket'],
		'assign_assigned_others' => $wpsp_agent_settings['agent_allow_assign_ticket'],
		'cng_tkt_sts_unassigned' => 0,
		'cng_tkt_sts_assigned_me' => 1,
		'cng_tkt_sts_assigned_others' => 0,
		'cng_tkt_field_unassigned' => 0,
		'cng_tkt_field_assigned_me' => 1,
		'cng_tkt_field_assigned_others' => 0,
		'cng_tkt_ao_unassigned' => 0,
		'cng_tkt_ao_assigned_me' => 1,
		'cng_tkt_ao_assigned_others' => 0,
		'cng_tkt_rb_unassigned' => $wpsp_agent_settings['agent_allow_change_raised_by'],
		'cng_tkt_rb_assigned_me' => $wpsp_agent_settings['agent_allow_change_raised_by'],
		'cng_tkt_rb_assigned_others' => $wpsp_agent_settings['agent_allow_change_raised_by'],
		'reply_unassigned' => 0,
		'reply_assigned_me' => 1,
		'reply_assigned_others' => 0,
		'delete_unassigned' => $wpsp_agent_settings['agent_allow_delete_ticket'],
		'delete_assigned_me' => $wpsp_agent_settings['agent_allow_delete_ticket'],
		'delete_assigned_others' => $wpsp_agent_settings['agent_allow_delete_ticket'],
		'view_unassigned_timer' => 0,
		'view_assigned_me_timer'=> 1,
		'view_assigned_others_timer'=> 0
	);
}

if (!array_key_exists('3', $agent_role)) {
	$agent_role[3] = 	array(
	      'label' => __('Supervisor','supportcandy'),
	      'view_unassigned' => 0,
	      'view_assigned_me' => 1,
	      'view_assigned_others' => 0,
	      'assign_unassigned' => 0,
	      'assign_assigned_me' => 1,
	      'assign_assigned_others' => 0,
	      'cng_tkt_sts_unassigned' => 0,
	      'cng_tkt_sts_assigned_me' => 1,
	      'cng_tkt_sts_assigned_others' => 0,
	      'cng_tkt_field_unassigned' => 0,
	      'cng_tkt_field_assigned_me' => 1,
	      'cng_tkt_field_assigned_others' => 0,
	      'cng_tkt_ao_unassigned' => 0,
	      'cng_tkt_ao_assigned_me' => 1,
	      'cng_tkt_ao_assigned_others' => 0,
	      'cng_tkt_rb_unassigned' => $wpsp_agent_settings['supervisor_allow_change_raised_by'],
	      'cng_tkt_rb_assigned_me' => $wpsp_agent_settings['supervisor_allow_change_raised_by'],
	      'cng_tkt_rb_assigned_others' => $wpsp_agent_settings['supervisor_allow_change_raised_by'],
	      'reply_unassigned' => 0,
	      'reply_assigned_me' => 1,
	      'reply_assigned_others' => 0,
	      'delete_unassigned' => $wpsp_agent_settings['supervisor_allow_delete_ticket'],
	      'delete_assigned_me' => $wpsp_agent_settings['supervisor_allow_delete_ticket'],
	      'delete_assigned_others' => $wpsp_agent_settings['supervisor_allow_delete_ticket'],
				'view_unassigned_timer' => 0,
				'view_assigned_me_timer'=> 1,
				'view_assigned_others_timer'=> 0
			);
}

foreach ($agent_role as $key => $capabilities){
	if ($key == 1) {
		$capabilities['view_unassigned_timer'] = 1;
		$capabilities['view_assigned_me_timer'] = 1;
		$capabilities['view_assigned_others_timer'] = 1;
				
		$agent_role[$key] = $capabilities;
		update_option('wpsc_agent_role',$agent_role);
	}
}
update_option('wpsc_agent_role',$agent_role);
/**
 * Delete all support agents
 */
foreach ($agents as $agent) {

	$user_id = get_term_meta( $agent->term_id, 'user_id', true);
  $user = get_user_by('id',$user_id);
  if($user){
  	$user->remove_cap('wpsc_agent');
  }
	delete_term_meta($agent->term_id, 'wpsc_agents');
  wp_delete_term($agent->term_id, 'wpsc_agents');
}

/**
 * Get all WPSP agents
 */

$user_data = $wpdb->get_results("select * from {$wpdb->prefix}wpsp_users");

foreach ($user_data as $user) {
	$user_obj = get_user_by('id',$user->user_id);
	if(!$user_obj) continue;
	$user_info  = get_userdata($user->user_id);
	if(!$user_info) continue;
	if($user->role =='1'){
		$role_key=2; 
	}elseif ($user->role =='2') {
		$role_key=3;
	} else if($user->role =='3'){
		$role_key=1;
	}
	
	$term = wp_insert_term( 'agent_'.$user->user_id, 'wpsc_agents' );
	if (!is_wp_error($term) && isset($term['term_id'])) {
		add_term_meta ($term['term_id'], 'user_id', $user->user_id);
		add_term_meta ($term['term_id'], 'label', $user_info->display_name);
		add_term_meta ($term['term_id'], 'role',  $role_key);
		add_term_meta ($term['term_id'], 'agentgroup', '0');
		add_term_meta ($term['term_id'], 'first_name', $user_info->first_name);
		add_term_meta ($term['term_id'], 'last_name', $user_info->last_name);
		add_term_meta ($term['term_id'], 'nicename', $user_info->user_nicename);
		add_term_meta ($term['term_id'], 'email', $user_info->user_email);
		$user = get_user_by('id',$user->user_id);
		$user->add_cap('wpsc_agent');
		update_user_option($user->user_id,'wpsc_agent_role',$role_key);
	} 
}
// create assign agent rules for supervisor
$wpscimportfunction->register_post_type();

$assign_agent = get_terms([
	'taxonomy'   => 'wpsc_caa',
	'hide_empty' => false
]);

if ($assign_agent) {
	foreach ($assign_agent as $agent) {
		wp_delete_term($agent->term_id, 'wpsc_caa');
	}
}


$caa_rule = get_option('wpsp_caa_rule');

if ($caa_rule) {
	
	foreach ($caa_rule as $agent_rule) {
		
		$assigned_agents = array();
	
		foreach ($agent_rule['agents'] as $agt) {
			$agent_data = get_term_by('slug','agent_'.$agt,'wpsc_agents');
			$assigned_agents[] = $agent_data->term_id;
		}
		
		if ($agent_rule['condition']) {
			$conditions = $wpscimportfunction->import_all_conditions($agent_rule['condition']);
		}
		
		$term = wp_insert_term( $agent_rule['title'], 'wpsc_caa' );
		
		if (!is_wp_error($term) && isset($term['term_id'])) {
			$load_order = $wpdb->get_var("select max(meta_value) as load_order from {$wpdb->prefix}termmeta WHERE meta_key='wpsc_caa_load_order'");
			$load_order = $load_order ? $load_order : 0;
			add_term_meta ($term['term_id'], 'load_order', ++$load_order);
			add_term_meta ($term['term_id'], 'agent_ids', $assigned_agents);
			add_term_meta ($term['term_id'], 'conditions', '['.$conditions.']');
		}
		
	}
}