<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $current_user,$wpdb,$wpsupportplus,$wpscfunction,$wpscimportfunction;

if( !$current_user->has_cap('manage_options') ) exit();

/*
  Get all custom and agent-only fields
 */
$custom_fields = $wpscimportfunction->get_wpsc_custom_fields();
/*
  Get all categories
 */
$categories = $wpscimportfunction->get_wpsc_categories();
/**
 * Get field types
 */
$field_types = $wpscfunction->get_custom_field_types();

/*
  Delete all custom fields
*/
if ($custom_fields) {  
  foreach ($custom_fields as $custom_field) {
    $wpsc_tf_type = get_term_meta( $custom_field->term_id, 'wpsc_tf_type', true);
    if ($wpsc_tf_type!='0') {
			delete_term_meta($custom_field->term_id, 'wpsc_ticket_custom_fields');
      wp_delete_term($custom_field->term_id, 'wpsc_ticket_custom_fields');
    }
  }
}

// Custom fileds localise
$custom_fields_localize = get_option('wpsc_custom_fields_localize');
if (!$custom_fields_localize) {
	$custom_fields_localize = array();
}

// Custom fields extra info
$custom_fields_extra_info = get_option('wpsc_custom_fields_extra_info');
if (!$custom_fields_extra_info) {
	 $custom_fields_extra_info = array();
}

/*
  Gets all default form fields and updates it..
 */
          
$form_fields = $wpscimportfunction->get_wpsp_form_fields();

foreach ($custom_fields as $custom_field) {
	$wpsc_tf_type = get_term_meta( $custom_field->term_id, 'wpsc_tf_type', true);
	
	if ($wpsc_tf_type == '0') {
		
		switch ($custom_field->slug) {
			case 'ticket_subject':
				$field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_form_order where field_key='ds'");
				update_term_meta($custom_field->term_id,'wpsc_tf_status',$field->status);
				update_term_meta($custom_field->term_id,'wpsc_tf_width',$field->full_width);
				update_term_meta($custom_field->term_id,'wpsc_tf_load_order',$field->load_order);	
				
				$label = get_term_meta( $custom_field->term_id, 'wpsc_tf_label', true);
				$custom_fields_localize['custom_fields_'.$custom_field->term_id] = $label;
				update_option('wpsc_custom_fields_localize', $custom_fields_localize);
				
				$extra_info = get_term_meta( $custom_field->term_id, 'wpsc_tf_extra_info', true);
				$custom_fields_extra_info['custom_fields_extra_info_' . $custom_field->term_id] = $extra_info;
				update_option('wpsc_custom_fields_extra_info', $custom_fields_extra_info);
				break;

			case 'ticket_description':
				$field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_form_order where field_key='dd'");
				update_term_meta($custom_field->term_id,'wpsc_tf_status',$field->status);
				update_term_meta($custom_field->term_id,'wpsc_tf_width',$field->full_width);
				update_term_meta($custom_field->term_id,'wpsc_tf_load_order',$field->load_order);
				$label = get_term_meta( $custom_field->term_id, 'wpsc_tf_label', true);
				$custom_fields_localize['custom_fields_'.$custom_field->term_id] = $label;
				update_option('wpsc_custom_fields_localize', $custom_fields_localize);
				
				$extra_info = get_term_meta( $custom_field->term_id, 'wpsc_tf_extra_info', true);
				$custom_fields_extra_info['custom_fields_extra_info_' . $custom_field->term_id] = $extra_info;
				update_option('wpsc_custom_fields_extra_info', $custom_fields_extra_info);
				break;

			case 'ticket_category':
				$field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_form_order where field_key='dc'");
				update_term_meta($custom_field->term_id,'wpsc_tf_status',$field->status);
				update_term_meta($custom_field->term_id,'wpsc_tf_width',$field->full_width);
				update_term_meta($custom_field->term_id,'wpsc_tf_load_order',$field->load_order);
				$label = get_term_meta( $custom_field->term_id, 'wpsc_tf_label', true);
				$custom_fields_localize['custom_fields_'.$custom_field->term_id] = $label;
				update_option('wpsc_custom_fields_localize', $custom_fields_localize);
				
				$extra_info = get_term_meta( $custom_field->term_id, 'wpsc_tf_extra_info', true);
				$custom_fields_extra_info['custom_fields_extra_info_' . $custom_field->term_id] = $extra_info;
				update_option('wpsc_custom_fields_extra_info', $custom_fields_extra_info);
				break;

			case 'ticket_priority':
				$field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_form_order where field_key='dp'");
				update_term_meta($custom_field->term_id,'wpsc_tf_status',$field->status);
				update_term_meta($custom_field->term_id,'wpsc_tf_width',$field->full_width);
				update_term_meta($custom_field->term_id,'wpsc_tf_load_order',$field->load_order);
				$label = get_term_meta( $custom_field->term_id, 'wpsc_tf_label', true);
				$custom_fields_localize['custom_fields_'.$custom_field->term_id] = $label;
				update_option('wpsc_custom_fields_localize', $custom_fields_localize);
				
				$extra_info = get_term_meta( $custom_field->term_id, 'wpsc_tf_extra_info', true);
				$custom_fields_extra_info['custom_fields_extra_info_' . $custom_field->term_id] = $extra_info;
				update_option('wpsc_custom_fields_extra_info', $custom_fields_extra_info);
				break;
			}
			
	}
}

/*
  Get Category id
 */
$category = get_term_by('slug','ticket_category','wpsc_ticket_custom_fields');
$category_id = $category->term_id;

/*
  Gets all custom fields and import into supportcandy
 */
$wpsp_custom_fields = $wpscimportfunction->get_wpsp_custom_fields();

foreach ($wpsp_custom_fields as $c_field) {

	if ($c_field->field_options) {
		$field_options= unserialize($c_field->field_options);
  }

	$term = wp_insert_term( $c_field->label, 'wpsc_ticket_custom_fields' );

	if (!is_wp_error($term) && isset($term['term_id'])) {
		
		$agent_load_order = $wpdb->get_var("select max(meta_value) as load_order from {$wpdb->prefix}termmeta WHERE meta_key='wpsc_tf_load_order'");
		add_term_meta ($term['term_id'], 'wpsc_tf_label', $c_field->label);
	  add_term_meta ($term['term_id'], 'wpsc_tf_extra_info','');
		if($c_field->isVarFeild == '1'){
			add_term_meta ($term['term_id'], 'agentonly', '1');
			add_term_meta ($term['term_id'], 'wpsc_tf_load_order', ++$agent_load_order);
		} else {
			add_term_meta ($term['term_id'], 'agentonly', '0'); 
			$load_order = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_form_order where field_key = $c_field->id");
			if ($load_order->full_width == '0') {
				add_term_meta ($term['term_id'], 'wpsc_tf_width', '1/2');
			}else {
				add_term_meta ($term['term_id'], 'wpsc_tf_width', '1');
			}
			add_term_meta ($term['term_id'], 'wpsc_tf_status', $load_order->status);
			add_term_meta ($term['term_id'], 'wpsc_tf_load_order',$load_order->load_order);
		}
		
		$field_type = $c_field->field_type; 
		if ($c_field->field_type == '7') {
			$field_type = 11;
		} else if ($c_field->field_type == '8') {
			$field_type = 10;
		} else if($c_field->field_type == '9'){
			$field_type = 7;
		} elseif ($c_field->field_type == '10') {
			$field_type = 8;
		} elseif ($c_field->field_type == '11') {
			$field_type = 12;
		} elseif ($c_field->field_type == '12') {
			$field_type = 13;
		} elseif ($c_field->field_type == '13') {
			$field_type = 14;
		}
		
		add_term_meta ($term['term_id'], 'wpsc_tf_type', $field_type);
		add_term_meta ($term['term_id'], 'wpsc_tf_options', $field_options);
		add_term_meta ($term['term_id'], 'wpsc_tf_required',  $c_field->required);
		add_term_meta ($term['term_id'], 'wpsc_tf_personal_info', ' ');
		
		$wpsc_tf_visibility = array();
	
		if($c_field->field_categories){
			$old_conditions = explode(',', $c_field->field_categories);
			foreach ( $old_conditions as $key => $value) {
				$wpsp_category = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_catagories where id = ".$value);
				$category_data = get_term_by('name',$wpsp_category->name,'wpsc_categories');
				$wpsc_tf_visibility[] = $category_id.'--'.$category_data->term_id;
			}
		}
		
		
		add_term_meta ($term['term_id'], 'wpsc_tf_visibility', $wpsc_tf_visibility);
		
		$get_custom_field_status = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order where field_key = ".$c_field->id);
		$flag_tl_status = false;
		$ticket_filter_type = 'string';
		
		if ($field_type == '9' ) {
			$ticket_filter_type = 'number';
		} elseif ($field_type == '6') {
			$ticket_filter_type = 'date';
		}
		
		if(isset($get_custom_field_status)){
			
			if ($get_custom_field_status->agent_visible) {
				$flag_tl_status = true;
				add_term_meta ($term['term_id'], 'wpsc_agent_ticket_list_status', '1');
				add_term_meta ($term['term_id'], 'wpsc_tl_agent_load_order', $get_custom_field_status->load_order);
			} else {
				add_term_meta ($term['term_id'], 'wpsc_agent_ticket_list_status', '0');
			}
		
			if ($get_custom_field_status->customer_visible) {
				$flag_tl_status = true;
				add_term_meta ($term['term_id'], 'wpsc_customer_ticket_list_status', '1');
				add_term_meta ($term['term_id'], 'wpsc_tl_customer_load_order', $get_custom_field_status->load_order);
			}else {
				add_term_meta ($term['term_id'], 'wpsc_customer_ticket_list_status', '0');
			}
			
			if ($flag_tl_status) {
				add_term_meta ($term['term_id'], 'wpsc_allow_orderby', '1');
				add_term_meta($term['term_id'],'wpsc_allow_ticket_list','1');
			} else {
				add_term_meta($term['term_id'],'wpsc_allow_ticket_list','0');
			}
	
			$flag_tf_status = false;

			if ($get_custom_field_status->customer_filter) {
				$flag_tf_status = true;
				add_term_meta ($term['term_id'], 'wpsc_customer_ticket_filter_status', '1');
				add_term_meta ($term['term_id'], 'wpsc_ticket_filter_type', $ticket_filter_type);
				add_term_meta($term['term_id'],'wpsc_filter_customer_load_order',$get_custom_field_status->load_order);
			} else {
				add_term_meta ($term['term_id'], 'wpsc_customer_ticket_filter_status', '0');
			}
		
			if ($get_custom_field_status->agent_filter) {
				$flag_tf_status = true;
				add_term_meta ($term['term_id'], 'wpsc_agent_ticket_filter_status', '1');
				add_term_meta ($term['term_id'], 'wpsc_ticket_filter_type', $ticket_filter_type);
				add_term_meta ($term['term_id'], 'wpsc_filter_agent_load_order', $get_custom_field_status->load_order);
			} else {
				add_term_meta ($term['term_id'], 'wpsc_agent_ticket_filter_status', '0');	
			} 
		
			if($flag_tf_status) {
				add_term_meta ($term['term_id'], 'wpsc_allow_ticket_filter', '1');
			} else {
				add_term_meta ($term['term_id'], 'wpsc_allow_ticket_filter', '0');
			}
		}
		$label = get_term_meta( $term['term_id'], 'wpsc_tf_label', true);
		$custom_fields_localize['custom_fields_'.$term['term_id']] = $label;
		update_option('wpsc_custom_fields_localize', $custom_fields_localize);
		
		$extra_info = get_term_meta( $term['term_id'], 'wpsc_tf_extra_info', true);
		$custom_fields_extra_info['custom_fields_extra_info_' . $term['term_id']] = $extra_info;
		update_option('wpsc_custom_fields_extra_info', $custom_fields_extra_info);
	}
}