<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $current_user,$wpdb,$wpscimportfunction;

if( !$current_user->has_cap('manage_options') ) exit();

$priorities = $wpscimportfunction->get_wpsc_priorities();

if ($priorities) {
  foreach ($priorities as $priority) {
		delete_term_meta($priority->term_id, 'wpsc_priorities');
    wp_delete_term($priority->term_id, 'wpsc_priorities');
  }
}

$wpsp_priorities = $wpscimportfunction->get_wpsp_priorities();

$wpsc_custom_priority_localize =  get_option('wpsc_custom_priority_localize');
if(!$wpsc_custom_priority_localize){
	$wpsc_custom_priority_localize = array();
}

foreach ($wpsp_priorities as $key => $priority) {
  $term = wp_insert_term($priority->name, 'wpsc_priorities' );
  if (!is_wp_error($term) && isset($term['term_id'])) {
    add_term_meta ($term['term_id'], 'wpsc_priority_load_order', $priority->load_order);
    add_term_meta ($term['term_id'], 'wpsc_priority_color', '#FFFFFF');
    add_term_meta ($term['term_id'], 'wpsc_priority_background_color', $priority->color);
		$wpsc_custom_priority_localize['custom_priority_'.$term['term_id']] = $priority->name;
		update_option('wpsc_custom_priority_localize', $wpsc_custom_priority_localize);
  }
}