<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $current_user,$wpdb,$wpscimportfunction,$wpsupportplus;

if( !$current_user->has_cap('manage_options') ) exit();

/*
		Import all SupportPlus General Settings
 */

//Get Default Category 

$wpsp_default_category = $wpsupportplus->functions->get_default_category();

$wp_category_name = $wpdb->get_var("SELECT name from {$wpdb->prefix}wpsp_catagories where id = ".$wpsp_default_category);
if($wp_category_name){
	$category_data = get_term_by('name',$wp_category_name, 'wpsc_categories');
	update_option('wpsc_default_ticket_category',$category_data->term_id);
}


//Get Default Status

$wpsp_default_status = $wpsupportplus->functions->get_default_status();

$wpsp_status_name = $wpdb->get_var("select name from {$wpdb->prefix}wpsp_custom_status where id = ".$wpsp_default_status."");
if ($wpsp_status_name) {
	$status_data = get_term_by('name',$wpsp_status_name, 'wpsc_statuses');
	update_option('wpsc_default_ticket_status',$status_data->term_id);
}


// Get Ticket Status after customer reply

$wp_after_customer_reply = $wpsupportplus->functions->get_customer_reply_status();

if (!$wp_after_customer_reply) {
	update_option('wpsc_ticket_status_after_customer_reply','');
}	else {

	$status_cust_name = $wpdb->get_var("select name from {$wpdb->prefix}wpsp_custom_status where id = ".$wp_after_customer_reply."");
	$status_cust_reply = get_term_by('name',$status_cust_name, 'wpsc_statuses');
	update_option('wpsc_ticket_status_after_customer_reply',$status_cust_reply->term_id);

}

//Get Ticket  Status after agent reply

$wp_after_agent_reply = $wpsupportplus->functions->get_agent_reply_status();
if (!$wp_after_agent_reply) {
	update_option('wpsc_ticket_status_after_agent_reply','');
} else {

	$status_agent_name = $wpdb->get_var("select name from {$wpdb->prefix}wpsp_custom_status where id = ".$wp_after_agent_reply."");
	$status_agent_reply = get_term_by('name',$status_agent_name,'wpsc_statuses');
	update_option('wpsc_ticket_status_after_agent_reply',$status_agent_reply->term_id);

}

//Allow customer to close ticket

$wp_allow_customer_to_close_ticket = $wpsupportplus->functions->is_close_btn_allowed();
if ($wp_allow_customer_to_close_ticket) {
  update_option('wpsc_allow_customer_close_ticket',$wp_allow_customer_to_close_ticket);
}

//Get close ticket status

$wp_close_ticket_status = $wpsupportplus->functions->get_close_btn_status();

if ($wp_close_ticket_status) {
	
	$wp_close_ticket_status_name = $wpdb->get_var("select name from {$wpdb->prefix}wpsp_custom_status where id = ".$wp_close_ticket_status."");
	$wpsc_close_ticket_status    = get_term_by('name',$wp_close_ticket_status_name, 'wpsc_statuses');

	if ($wpsc_close_ticket_status) {
		update_option('wpsc_close_ticket_status',$wpsc_close_ticket_status->term_id);
	}
	
}

// Get Default Settings of SupportPlus
$default_settings = $wpsupportplus->functions->get_default_filters();

//Get Unresolved Statuses
$wpsc_tl_customer_status = get_option('wpsc_tl_customer_unresolve_statuses');
$wpsc_tl_agent_status    = get_option('wpsc_tl_agent_unresolve_statuses');

$wpsc_customer_unresolved_statuses = array();
$wpsc_agent_unresolved_statuses    = array();

//Importing Hide Status of Customer/Agent of SupportPlus

if (isset($default_settings['customer_hide_statuses'])) {
	
	$sp_cust_status = $wpdb->get_results("select id from {$wpdb->prefix}wpsp_custom_status");
	$wpsp_cust_statuses = array();
	
	foreach ($sp_cust_status as $status) {
		$wpsp_cust_statuses[] = $status->id;
	}

	$cust_result = array_diff($wpsp_cust_statuses,$default_settings['customer_hide_statuses']);
	foreach ($cust_result as $status_id) {
		
		$sp_cust_status_name =  $wpdb->get_var("select name from {$wpdb->prefix}wpsp_custom_status where id = " .$status_id."");
		$status_cust_unresolved = get_term_by('name',$sp_cust_status_name,'wpsc_statuses');
		$wpsc_customer_unresolved_statuses[] = $status_cust_unresolved->term_id;
	}
}

if (isset($default_settings['agent_hide_statuses'])) {
	
	$sp_status = $wpdb->get_results("select id from {$wpdb->prefix}wpsp_custom_status");
	$wpsp_agent_statuses = array();
	
	foreach ($sp_status as $agent_status) {
		$wpsp_agent_statuses[] = $agent_status->id;
	}
	
	$agent_result = array_diff($wpsp_agent_statuses,$default_settings['agent_hide_statuses']);
	
	foreach ($agent_result as $agent_status_id) {
		
		$sp_agent_status_name =  $wpdb->get_var("select name from {$wpdb->prefix}wpsp_custom_status where id = " .$agent_status_id."");
		$status_agent_unresolved = get_term_by('name',$sp_agent_status_name,'wpsc_statuses');
		$wpsc_agent_unresolved_statuses[] = $status_agent_unresolved->term_id;
	}

}

update_option('wpsc_tl_customer_unresolve_statuses',$wpsc_customer_unresolved_statuses);
update_option('wpsc_tl_agent_unresolve_statuses',$wpsc_agent_unresolved_statuses);

//Get Default Priority

$wpsp_default_priority = $wpsupportplus->functions->get_default_priority();

//Importing default priority of SupportPlus
$wpsp_priority_name = $wpdb->get_var("select name from {$wpdb->prefix}wpsp_custom_priority WHERE id =".$wpsp_default_priority. " ");
if ($wpsp_priority_name) {
	$priority_data = get_term_by('name',$wpsp_priority_name,'wpsc_priorities');
	update_option('wpsc_default_ticket_priority',$priority_data->term_id);
}


//Get Ticket Id type
$wpsp_ticket_id_type = $wpsupportplus->functions->get_ticket_id_sequence();
update_option('wpsc_ticket_id_type',$wpsp_ticket_id_type);


//Get reply_form_position
$wpsp_reply_form_position = $wpsupportplus->functions->get_reply_form_position();

if($wpsp_reply_form_position){
  update_option('wpsc_reply_form_position',$wpsp_reply_form_position);
}

//Get calendar date format
$wp_calendar_date_format = $wpsupportplus->functions->get_date_format();

if($wp_calendar_date_format){
  update_option('wpsc_calender_date_format',$wp_calendar_date_format);
}

//Get Attachment Max File Size
$wp_attachment_max_file = $wpsupportplus->functions->get_attachment_size();

if($wp_attachment_max_file){
  update_option('wpsc_attachment_max_filesize',$wp_attachment_max_file);
}

//Allow Guest Tickets
$wp_allow_guest_ticket= $wpsupportplus->functions->is_allow_guest_ticket();

if($wp_allow_guest_ticket){
  update_option('wpsc_allow_guest_ticket',$wp_allow_guest_ticket);
}

// Get Ticket Alice 
$ticket_label     = $wpsupportplus->functions->get_ticket_lable();
$ticket_id_prefix = $wpsupportplus->functions->get_ticket_id_prefix();
$wp_ticket_alice  = $ticket_label." ".$ticket_id_prefix;

if($wp_ticket_alice){
  update_option('wpsc_ticket_alice',$wp_ticket_alice);
}

//Get Public Ticket Mode

$wp_public_ticket_mode = $wpsupportplus->functions->make_ticket_as_public();
if($wp_public_ticket_mode){
  update_option('wpsc_ticket_public_mode',$wp_public_ticket_mode);
}

// Get Default Login of SupportPlus

$wp_login_url = $wpsupportplus->functions->get_default_login();
if($wp_login_url =='1'){
  update_option('wpsc_default_login_setting',$wp_login_url);
}
else if ($wp_login_url =='0') {
  update_option('wpsc_default_login_setting','2');
}

//Get Thank You Page Redirect URL

$wp_thank_you_redirect_url   = $wpsupportplus->functions->get_guest_ticket_redirect_url();
$wpsc_thank_you_redirect_url = get_option('wpsc_thankyou_url');

if($wp_thank_you_redirect_url){
  update_option('wpsc_thankyou_url',$wp_thank_you_redirect_url);
}

//Import all Additional settings

if($default_settings['customer_par_page_tickets']){
  update_option('wpsc_tl_customer_no_of_tickets',$default_settings['customer_par_page_tickets']);
}

if($default_settings['agent_par_page_tickets']) {
  update_option('wpsc_tl_agent_no_of_tickets',$default_settings['agent_par_page_tickets']);
}

if($default_settings['customer_orderby_order']) {
  update_option('wpsc_tl_customer_orderby_order',$default_settings['customer_orderby_order']);
}

if ($default_settings['agent_orderby_order']) {
  update_option('wpsc_tl_agent_orderby_order',$default_settings['agent_orderby_order']);
}

$wp_cap = $wpsupportplus->functions-> toggle_button_disable_captcha();

if ($wp_cap == 'all' || $wp_cap == 'guest') {
  update_option('wpsc_captcha','1');
} else {
  update_option('wpsc_captcha','0');
}

$agents = $wpscimportfunction->wpsc_get_all_agents();

if ($agents) {

	foreach ($agents as $agent) {
		
		$signature = get_user_meta($agent->term_id,'wpsp_agent_signature',true);
		if($signature){
			update_user_meta($wp_user_data->ID,'wpsc_agent_signature',$signature);
		}

	}
		
}

$timerSettings = get_option('wpsp_timer_settings' );
update_option('wpsc_timer_visibility_for_customer',$timerSettings['timer_visibility']);
$wpsc_allow_reply_to_close_ticket = array('agents');
$wp_reply_to_close_ticket         = $wpsupportplus->functions-> toggle_button_reply_closed_tickets();
if ($wp_reply_to_close_ticket != 0) {
	$wpsc_allow_reply_to_close_ticket[] = 'customer';

}
update_option('wpsc_allow_reply_to_close_ticket',$wpsc_allow_reply_to_close_ticket);
update_option('wpsc_on_and_off_auto_refresh',0);

// Check SP table Timer Present or not
$sp_tbl_timer = $wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}wpsp_timer'");
if ($sp_tbl_timer) {
	$sc_tbl_timer = $wpdb->get_var("SHOW TABLES LIKE '{$wpdb->prefix}wpsc_timer'");
	if(!$sc_tbl_timer){
		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		
		$collate = 'CHARACTER SET utf8 COLLATE utf8_general_ci';
		
		$tables = "CREATE TABLE {$wpdb->prefix}wpsc_timer (
			id int(11) NOT NULL AUTO_INCREMENT,
			post_id int(11) NULL DEFAULT NULL,
			start_time VARCHAR(100) NULL DEFAULT NULL,
			end_time VARCHAR(100) NULL DEFAULT NULL,
			timer_status int(11) DEFAULT 1,
			time_spend VARCHAR(100) NULL DEFAULT NULL,
			PRIMARY KEY  (id)
		) $collate; ";

		dbDelta( $tables );
	}
}