<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $current_user,$wpdb,$wpscimportfunction;

if( !$current_user->has_cap('manage_options') ) exit();

$statuses = $wpscimportfunction->get_wpsc_status();

if($statuses){
  foreach ($statuses as $sc_status) {
		delete_term_meta($sc_status->term_id, 'wpsc_statuses');
    wp_delete_term($sc_status->term_id, 'wpsc_statuses');
  }
}

$wpsp_statuses = $wpscimportfunction->get_wpsp_status();

$wpsc_custom_status_localize =  get_option('wpsc_custom_status_localize');
if(!$wpsc_custom_status_localize){
	$wpsc_custom_status_localize = array();
}

foreach ($wpsp_statuses as $key => $status) {

  $term = wp_insert_term($status->name, 'wpsc_statuses' );
  
  if (!is_wp_error($term) && isset($term['term_id'])) {
    add_term_meta ($term['term_id'], 'wpsc_status_load_order', $status->load_order);
    add_term_meta ($term['term_id'], 'wpsc_status_color', '#FFFFFF');
    add_term_meta ($term['term_id'], 'wpsc_status_background_color', $status->color);
		$wpsc_custom_status_localize['custom_status_'.$term['term_id']] = $status->name;
		update_option('wpsc_custom_status_localize', $wpsc_custom_status_localize);	
  }
  
}