<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $current_user,$wpdb,$wpsupportplus;

if( !$current_user->has_cap('manage_options') ) exit();


/**
 *   * Get all form fields
*/
 $wpsc_ticket_list_fields = get_terms([
 	'taxonomy'   => 'wpsc_ticket_custom_fields',
 	'hide_empty' => false,
 	]);
	
/*
	Import all fields
 */
foreach ($wpsc_ticket_list_fields as $c_field) {
	if ($c_field->slug == 'ticket_id') {
		
		$wpsp_get_tl_field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order WHERE field_key = 'id'");
		
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_list_status', $wpsp_get_tl_field->agent_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_list_status', $wpsp_get_tl_field->customer_visible);
	  update_term_meta ($c_field->term_id, 'wpsc_tl_customer_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_filter_status', $wpsp_get_tl_field->agent_filter);
	  update_term_meta ($c_field->term_id, 'wpsc_filter_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_filter_status', $wpsp_get_tl_field->customer_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_customer_load_order', $wpsp_get_tl_field->load_order);
	
	}elseif ($c_field->slug =='customer_name') {
		
		$wpsp_get_tl_field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order WHERE field_key = 'raised_by'");
		
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_list_status', $wpsp_get_tl_field->agent_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_list_status', $wpsp_get_tl_field->customer_visible);
	  update_term_meta ($c_field->term_id, 'wpsc_tl_customer_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_filter_status', $wpsp_get_tl_field->agent_filter);
	  update_term_meta ($c_field->term_id, 'wpsc_filter_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_filter_status', $wpsp_get_tl_field->customer_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_customer_load_order', $wpsp_get_tl_field->load_order);


	} elseif ($c_field->slug == 'ticket_status') {
		
		$wpsp_get_tl_field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order WHERE field_key = 'status'");
		
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_list_status', $wpsp_get_tl_field->agent_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_list_status', $wpsp_get_tl_field->customer_visible);
	  update_term_meta ($c_field->term_id, 'wpsc_tl_customer_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_filter_status', $wpsp_get_tl_field->agent_filter);
	  update_term_meta ($c_field->term_id, 'wpsc_filter_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_filter_status', $wpsp_get_tl_field->customer_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_customer_load_order', $wpsp_get_tl_field->load_order);

		
	}elseif ($c_field->slug == 'ticket_subject') {
	
		$wpsp_get_tl_field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order WHERE field_key = 'subject'");
		
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_list_status', $wpsp_get_tl_field->agent_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_list_status', $wpsp_get_tl_field->customer_visible);
	  update_term_meta ($c_field->term_id, 'wpsc_tl_customer_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_filter_status', $wpsp_get_tl_field->agent_filter);
	  update_term_meta ($c_field->term_id, 'wpsc_filter_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_filter_status', $wpsp_get_tl_field->customer_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_customer_load_order', $wpsp_get_tl_field->load_order);

	} elseif ($c_field->slug == 'ticket_priority') {
	
		$wpsp_get_tl_field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order WHERE field_key = 'priority'");
		
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_list_status', $wpsp_get_tl_field->agent_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_list_status', $wpsp_get_tl_field->customer_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_customer_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_filter_status', $wpsp_get_tl_field->agent_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_filter_status', $wpsp_get_tl_field->customer_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_customer_load_order', $wpsp_get_tl_field->load_order);

	}elseif ($c_field->slug == 'ticket_category') {

		$wpsp_get_tl_field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order WHERE field_key = 'category'");
		
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_list_status', $wpsp_get_tl_field->agent_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_list_status', $wpsp_get_tl_field->customer_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_customer_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_filter_status', $wpsp_get_tl_field->agent_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_filter_status', $wpsp_get_tl_field->customer_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_customer_load_order', $wpsp_get_tl_field->load_order);

	}elseif ($c_field->slug == 'date_created') {
		
		$wpsp_get_tl_field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order WHERE field_key = 'date_created'");
		
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_list_status', $wpsp_get_tl_field->agent_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_list_status', $wpsp_get_tl_field->customer_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_customer_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_filter_status', $wpsp_get_tl_field->agent_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_filter_status', $wpsp_get_tl_field->customer_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_customer_load_order', $wpsp_get_tl_field->load_order);

	}elseif ($c_field->slug == 'date_updated') {
		
		$wpsp_get_tl_field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order WHERE field_key = 'date_updated'");
	
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_list_status', $wpsp_get_tl_field->agent_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_list_status', $wpsp_get_tl_field->customer_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_customer_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_filter_status', $wpsp_get_tl_field->agent_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_filter_status', $wpsp_get_tl_field->customer_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_customer_load_order', $wpsp_get_tl_field->load_order);
	
	} elseif ($c_field->slug == 'assigned_agent') {
		
		$wpsp_get_tl_field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order WHERE field_key = 'assigned_agent'");
		
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_list_status', $wpsp_get_tl_field->agent_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_list_status', $wpsp_get_tl_field->customer_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_customer_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_filter_status', $wpsp_get_tl_field->agent_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_filter_status', $wpsp_get_tl_field->customer_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_customer_load_order', $wpsp_get_tl_field->load_order);

	} elseif ($c_field->slug == 'agent_created') {
		
		$wpsp_get_tl_field = $wpdb->get_row("select * from {$wpdb->prefix}wpsp_ticket_list_order WHERE field_key = 'created_agent'");
		
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_list_status', $wpsp_get_tl_field->agent_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_list_status', $wpsp_get_tl_field->customer_visible);
		update_term_meta ($c_field->term_id, 'wpsc_tl_customer_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_agent_ticket_filter_status', $wpsp_get_tl_field->agent_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_agent_load_order', $wpsp_get_tl_field->load_order);
		update_term_meta ($c_field->term_id, 'wpsc_customer_ticket_filter_status', $wpsp_get_tl_field->customer_filter);
		update_term_meta ($c_field->term_id, 'wpsc_filter_customer_load_order', $wpsp_get_tl_field->load_order);	
	}
}