<?php 
/**
 * Plugin Name: SupportCandy - WP Support Plus Import
 * Plugin URI: https://supportcandy.net
 * Description: Imports WP Support Plus tickets and settings to SupportCandy
 * Version: 1.0.0
 * Author: SupportCandy
 * Author URI: https://supportcandy.net/
 * Requires at least: 4.4
 * Tested up to: 5.1
 * Text Domain: wpsc-import-sc
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

if ( ! class_exists( 'WPSC_SC_IMPORT' ) ) :
  
    final class WPSC_SC_IMPORT {
      
        /**
         * Constructor for import
         */
        public function __construct() {
            $this->define_constants();
            $this->includes();
            add_action( 'init', array($this,'load_hooks') );
						add_action('init', array($this, 'register_post_type'));
        }
        
        /**
         * Define constants which can be used anywhere
         */
        function define_constants() {
            $this->define('WPSC_SCIMP_PLUGIN_FILE', __FILE__);
            $this->define('WPSC_SCIMP_ABSPATH', dirname(__FILE__) . '/');
            $this->define('WPSC_SCIMP_PLUGIN_URL', plugin_dir_url( __FILE__ ) );
            $this->define('WPSC_SCIMP_PLUGIN_BASENAME', plugin_basename(__FILE__));
        }
        
        /**
         * Include files that loads classes
         */
        public function includes() {
            include_once( WPSC_SCIMP_ABSPATH . 'class-wpsc-sc-import.php' );
						include_once( WPSC_SCIMP_ABSPATH . 'class-wp-import-functions.php' );

			  }
        
        /**
         * Define constants based on given name and value
         */
        private function define($name, $value) {
            if (!defined($name)) {
                define($name, $value);
            }
        }
        
        /**
         * Load hooks and filters for this add-on
         */
        public function load_hooks(){
          
            if( is_admin() ){
              
                $admin = new WPSC_SCIMP_Admin();
                
                // Add script & submenu
                add_action( 'admin_enqueue_scripts', array( $admin, 'loadScripts') );
                add_action( 'admin_menu', array($admin,'register_dashboard_menu') );
								
								// setting import
								add_action('wp_ajax_wpsc_run_setting_import', array($admin, 'run_setting_import') );
								add_action('wp_ajax_wpsc_run_ticket_import', array($admin, 'run_ticket_import') );
								add_action('wp_ajax_wpsc_run_import_addons', array($admin, 'run_import_addons') );

            }
          
        }
				
				function register_post_type() {
					
						include( WPSC_SCIMP_ABSPATH . 'register_post_type.php' );
				}
      
    }
  
endif;

new WPSC_SC_IMPORT();